From a90b9c3c54eabe4e9429911417a8f3196b9036c2 Mon Sep 17 00:00:00 2001
From: Ian Jackson <ijackson@chiark.greenend.org.uk>
Date: Fri, 21 Jan 2022 20:28:05 +0000
Subject: [PATCH 1/4] * inotify.c: Document hazard of unlimited buffering

---
 src/inotify.c | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/src/inotify.c b/src/inotify.c
index e92ad40abc..b676ea216a 100644
--- a/src/inotify.c
+++ b/src/inotify.c
@@ -316,6 +316,9 @@ inotify_callback (int fd, void *_)
   if (ioctl (fd, FIONREAD, &to_read) < 0)
     report_file_notify_error ("Error while retrieving file system events",
 			      Qnil);
+  // FIXME: feeding the value from FIONREAD to a memory allocator is unwise
+  // Sadly the inotify event buffer parsing algorithm is not capable of
+  // handling the case where we read only part of a kernel event.
   USE_SAFE_ALLOCA;
   char *buffer = SAFE_ALLOCA (to_read);
   ssize_t n = read (fd, buffer, to_read);
-- 
2.20.1

